﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.Loaded                            += Window_Loaded;
            this.contentScrollViewer.ScrollChanged += contentScrollViewer_ScrollChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 윈도우 로드시 처리하기 - Window_Loaded(sender, e)

        /// <summary>
        /// 윈도우 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            for(int y = 0; y < 1000; y++)
            {
                RowDefinition rowDefinition = new RowDefinition();

                rowDefinition.Height = new GridLength(25d, GridUnitType.Pixel);

                this.contentGrid.RowDefinitions.Add(rowDefinition);
            }

            for(int y = 0; y < 1000; y++)
            {
                for(int x = 0; x < 5; x++)
                {
                    TextBlock textBlock = new TextBlock();

                    textBlock.Margin     = new Thickness(3);
                    textBlock.Foreground = Brushes.Black;
                    textBlock.Text       = string.Format("셀({0},{1})", y, x);

                    Border border = new Border();

                    border.BorderThickness = new Thickness(0.5);
                    border.BorderBrush     = Brushes.DarkGray;

                    border.Child = textBlock;

                    Grid.SetRow   (border, y);
                    Grid.SetColumn(border, x);

                    this.contentGrid.Children.Add(border);
                }
            }
        }

        #endregion
        #region 컨텐트 스크롤 뷰어 스크롤 변경시 처리하기 - contentScrollViewer_ScrollChanged(sender, e)

        /// <summary>
        /// 컨텐트 스크롤 뷰어 스크롤 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void contentScrollViewer_ScrollChanged(object sender, ScrollChangedEventArgs e)
        {
            this.headerScrollViewer.ScrollToHorizontalOffset(this.contentScrollViewer.ContentHorizontalOffset);
        }

        #endregion
    }
}